package com.logntw.eva.spring;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;


public final class Main 
{
	private Main(){}
	public static void main(String... args) throws Exception
	{
		ApplicationContext context= new ClassPathXmlApplicationContext("greeting.xml");
				
		long start, end;					
		final int LOOP = 1000000;			
				
				
		context.getBean("ServiceA");
		context.getBean("ServiceB", "greeting");
		context.getBean("GreetingServiceC");
		context.getBean("GreetingServiceD", "greeting");
				
		start = System.currentTimeMillis();		
		for(int i = 0; i < LOOP ; i ++)			
		{
			context.getBean("ServiceA");
		}
		end = System.currentTimeMillis();
		System.out.println("The creation of "+LOOP+" ServiceA objects spent "+ (end - start) + " milliseconds.");
		
		
		start = System.currentTimeMillis();		
		for(int i = 0; i < LOOP ; i ++)
		{
			context.getBean("ServiceB", "greeting");
		}
		end = System.currentTimeMillis();
		System.out.println("The creation of "+LOOP+" ServiceB objects spent "+ (end - start) + " milliseconds.");
		
		start = System.currentTimeMillis();		
		for(int i = 0; i < LOOP ; i ++)
		{
			context.getBean("GreetingServiceC");
		}
		end = System.currentTimeMillis();
		System.out.println("The creation of "+LOOP+" GreetingServiceC objects spent "+ (end - start) + " milliseconds.");
		
		
		start = System.currentTimeMillis();		
		for(int i = 0; i < LOOP ; i ++)
		{
			context.getBean("GreetingServiceD", "greeting");
		}
		end = System.currentTimeMillis();
		System.out.println("The creation of "+LOOP+" GreetingServiceD objects spent "+ (end - start) + " milliseconds.");
		
		
		
		System.out.println("Press any key to exist.");
		System.in.read();
	}
}
